// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Logical node for event and status
 * </pre>
 *
 * Protobuf type {@code commonmodule.LogicalNodeForEventAndStatus}
 */
public final class LogicalNodeForEventAndStatus extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.LogicalNodeForEventAndStatus)
    LogicalNodeForEventAndStatusOrBuilder {
private static final long serialVersionUID = 0L;
  // Use LogicalNodeForEventAndStatus.newBuilder() to construct.
  private LogicalNodeForEventAndStatus(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private LogicalNodeForEventAndStatus() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new LogicalNodeForEventAndStatus();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_LogicalNodeForEventAndStatus_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_LogicalNodeForEventAndStatus_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.LogicalNodeForEventAndStatus.class, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder.class);
  }

  public static final int LOGICALNODE_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNode logicalNode_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNode field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNode() {
    return logicalNode_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNode.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNode getLogicalNode() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }

  public static final int BEH_FIELD_NUMBER = 2;
  private openfmb.commonmodule.ENS_BehaviourModeKind beh_;
  /**
   * <pre>
   * Behavior of the function
   * </pre>
   *
   * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
   * @return Whether the beh field is set.
   */
  @java.lang.Override
  public boolean hasBeh() {
    return beh_ != null;
  }
  /**
   * <pre>
   * Behavior of the function
   * </pre>
   *
   * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
   * @return The beh.
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_BehaviourModeKind getBeh() {
    return beh_ == null ? openfmb.commonmodule.ENS_BehaviourModeKind.getDefaultInstance() : beh_;
  }
  /**
   * <pre>
   * Behavior of the function
   * </pre>
   *
   * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_BehaviourModeKindOrBuilder getBehOrBuilder() {
    return beh_ == null ? openfmb.commonmodule.ENS_BehaviourModeKind.getDefaultInstance() : beh_;
  }

  public static final int EEHEALTH_FIELD_NUMBER = 3;
  private openfmb.commonmodule.ENS_HealthKind eEHealth_;
  /**
   * <pre>
   * Asset health
   * </pre>
   *
   * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
   * @return Whether the eEHealth field is set.
   */
  @java.lang.Override
  public boolean hasEEHealth() {
    return eEHealth_ != null;
  }
  /**
   * <pre>
   * Asset health
   * </pre>
   *
   * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
   * @return The eEHealth.
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_HealthKind getEEHealth() {
    return eEHealth_ == null ? openfmb.commonmodule.ENS_HealthKind.getDefaultInstance() : eEHealth_;
  }
  /**
   * <pre>
   * Asset health
   * </pre>
   *
   * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_HealthKindOrBuilder getEEHealthOrBuilder() {
    return eEHealth_ == null ? openfmb.commonmodule.ENS_HealthKind.getDefaultInstance() : eEHealth_;
  }

  public static final int HOTLINETAG_FIELD_NUMBER = 4;
  private openfmb.commonmodule.StatusSPS hotLineTag_;
  /**
   * <pre>
   * Hot line tag.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
   * @return Whether the hotLineTag field is set.
   */
  @java.lang.Override
  public boolean hasHotLineTag() {
    return hotLineTag_ != null;
  }
  /**
   * <pre>
   * Hot line tag.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
   * @return The hotLineTag.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getHotLineTag() {
    return hotLineTag_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : hotLineTag_;
  }
  /**
   * <pre>
   * Hot line tag.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getHotLineTagOrBuilder() {
    return hotLineTag_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : hotLineTag_;
  }

  public static final int REMOTEBLK_FIELD_NUMBER = 5;
  private openfmb.commonmodule.StatusSPS remoteBlk_;
  /**
   * <pre>
   * Remote control block.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
   * @return Whether the remoteBlk field is set.
   */
  @java.lang.Override
  public boolean hasRemoteBlk() {
    return remoteBlk_ != null;
  }
  /**
   * <pre>
   * Remote control block.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
   * @return The remoteBlk.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getRemoteBlk() {
    return remoteBlk_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : remoteBlk_;
  }
  /**
   * <pre>
   * Remote control block.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getRemoteBlkOrBuilder() {
    return remoteBlk_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : remoteBlk_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNode_ != null) {
      output.writeMessage(1, getLogicalNode());
    }
    if (beh_ != null) {
      output.writeMessage(2, getBeh());
    }
    if (eEHealth_ != null) {
      output.writeMessage(3, getEEHealth());
    }
    if (hotLineTag_ != null) {
      output.writeMessage(4, getHotLineTag());
    }
    if (remoteBlk_ != null) {
      output.writeMessage(5, getRemoteBlk());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNode_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNode());
    }
    if (beh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getBeh());
    }
    if (eEHealth_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getEEHealth());
    }
    if (hotLineTag_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getHotLineTag());
    }
    if (remoteBlk_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getRemoteBlk());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.LogicalNodeForEventAndStatus)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.LogicalNodeForEventAndStatus other = (openfmb.commonmodule.LogicalNodeForEventAndStatus) obj;

    if (hasLogicalNode() != other.hasLogicalNode()) return false;
    if (hasLogicalNode()) {
      if (!getLogicalNode()
          .equals(other.getLogicalNode())) return false;
    }
    if (hasBeh() != other.hasBeh()) return false;
    if (hasBeh()) {
      if (!getBeh()
          .equals(other.getBeh())) return false;
    }
    if (hasEEHealth() != other.hasEEHealth()) return false;
    if (hasEEHealth()) {
      if (!getEEHealth()
          .equals(other.getEEHealth())) return false;
    }
    if (hasHotLineTag() != other.hasHotLineTag()) return false;
    if (hasHotLineTag()) {
      if (!getHotLineTag()
          .equals(other.getHotLineTag())) return false;
    }
    if (hasRemoteBlk() != other.hasRemoteBlk()) return false;
    if (hasRemoteBlk()) {
      if (!getRemoteBlk()
          .equals(other.getRemoteBlk())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNode()) {
      hash = (37 * hash) + LOGICALNODE_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNode().hashCode();
    }
    if (hasBeh()) {
      hash = (37 * hash) + BEH_FIELD_NUMBER;
      hash = (53 * hash) + getBeh().hashCode();
    }
    if (hasEEHealth()) {
      hash = (37 * hash) + EEHEALTH_FIELD_NUMBER;
      hash = (53 * hash) + getEEHealth().hashCode();
    }
    if (hasHotLineTag()) {
      hash = (37 * hash) + HOTLINETAG_FIELD_NUMBER;
      hash = (53 * hash) + getHotLineTag().hashCode();
    }
    if (hasRemoteBlk()) {
      hash = (37 * hash) + REMOTEBLK_FIELD_NUMBER;
      hash = (53 * hash) + getRemoteBlk().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.LogicalNodeForEventAndStatus parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.LogicalNodeForEventAndStatus prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Logical node for event and status
   * </pre>
   *
   * Protobuf type {@code commonmodule.LogicalNodeForEventAndStatus}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.LogicalNodeForEventAndStatus)
      openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_LogicalNodeForEventAndStatus_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_LogicalNodeForEventAndStatus_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.LogicalNodeForEventAndStatus.class, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder.class);
    }

    // Construct using openfmb.commonmodule.LogicalNodeForEventAndStatus.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      beh_ = null;
      if (behBuilder_ != null) {
        behBuilder_.dispose();
        behBuilder_ = null;
      }
      eEHealth_ = null;
      if (eEHealthBuilder_ != null) {
        eEHealthBuilder_.dispose();
        eEHealthBuilder_ = null;
      }
      hotLineTag_ = null;
      if (hotLineTagBuilder_ != null) {
        hotLineTagBuilder_.dispose();
        hotLineTagBuilder_ = null;
      }
      remoteBlk_ = null;
      if (remoteBlkBuilder_ != null) {
        remoteBlkBuilder_.dispose();
        remoteBlkBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_LogicalNodeForEventAndStatus_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.LogicalNodeForEventAndStatus getDefaultInstanceForType() {
      return openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.LogicalNodeForEventAndStatus build() {
      openfmb.commonmodule.LogicalNodeForEventAndStatus result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.LogicalNodeForEventAndStatus buildPartial() {
      openfmb.commonmodule.LogicalNodeForEventAndStatus result = new openfmb.commonmodule.LogicalNodeForEventAndStatus(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.LogicalNodeForEventAndStatus result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNode_ = logicalNodeBuilder_ == null
            ? logicalNode_
            : logicalNodeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.beh_ = behBuilder_ == null
            ? beh_
            : behBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.eEHealth_ = eEHealthBuilder_ == null
            ? eEHealth_
            : eEHealthBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.hotLineTag_ = hotLineTagBuilder_ == null
            ? hotLineTag_
            : hotLineTagBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.remoteBlk_ = remoteBlkBuilder_ == null
            ? remoteBlk_
            : remoteBlkBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.LogicalNodeForEventAndStatus) {
        return mergeFrom((openfmb.commonmodule.LogicalNodeForEventAndStatus)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.LogicalNodeForEventAndStatus other) {
      if (other == openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance()) return this;
      if (other.hasLogicalNode()) {
        mergeLogicalNode(other.getLogicalNode());
      }
      if (other.hasBeh()) {
        mergeBeh(other.getBeh());
      }
      if (other.hasEEHealth()) {
        mergeEEHealth(other.getEEHealth());
      }
      if (other.hasHotLineTag()) {
        mergeHotLineTag(other.getHotLineTag());
      }
      if (other.hasRemoteBlk()) {
        mergeRemoteBlk(other.getRemoteBlk());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getBehFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getEEHealthFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getHotLineTagFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getRemoteBlkFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNode logicalNode_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> logicalNodeBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNode field is set.
     */
    public boolean hasLogicalNode() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNode.
     */
    public openfmb.commonmodule.LogicalNode getLogicalNode() {
      if (logicalNodeBuilder_ == null) {
        return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      } else {
        return logicalNodeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNode_ = value;
      } else {
        logicalNodeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(
        openfmb.commonmodule.LogicalNode.Builder builderForValue) {
      if (logicalNodeBuilder_ == null) {
        logicalNode_ = builderForValue.build();
      } else {
        logicalNodeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNode_ != null &&
          logicalNode_ != openfmb.commonmodule.LogicalNode.getDefaultInstance()) {
          getLogicalNodeBuilder().mergeFrom(value);
        } else {
          logicalNode_ = value;
        }
      } else {
        logicalNodeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNode() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNode.Builder getLogicalNodeBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
      if (logicalNodeBuilder_ != null) {
        return logicalNodeBuilder_.getMessageOrBuilder();
      } else {
        return logicalNode_ == null ?
            openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> 
        getLogicalNodeFieldBuilder() {
      if (logicalNodeBuilder_ == null) {
        logicalNodeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder>(
                getLogicalNode(),
                getParentForChildren(),
                isClean());
        logicalNode_ = null;
      }
      return logicalNodeBuilder_;
    }

    private openfmb.commonmodule.ENS_BehaviourModeKind beh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_BehaviourModeKind, openfmb.commonmodule.ENS_BehaviourModeKind.Builder, openfmb.commonmodule.ENS_BehaviourModeKindOrBuilder> behBuilder_;
    /**
     * <pre>
     * Behavior of the function
     * </pre>
     *
     * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
     * @return Whether the beh field is set.
     */
    public boolean hasBeh() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Behavior of the function
     * </pre>
     *
     * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
     * @return The beh.
     */
    public openfmb.commonmodule.ENS_BehaviourModeKind getBeh() {
      if (behBuilder_ == null) {
        return beh_ == null ? openfmb.commonmodule.ENS_BehaviourModeKind.getDefaultInstance() : beh_;
      } else {
        return behBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Behavior of the function
     * </pre>
     *
     * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
     */
    public Builder setBeh(openfmb.commonmodule.ENS_BehaviourModeKind value) {
      if (behBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        beh_ = value;
      } else {
        behBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Behavior of the function
     * </pre>
     *
     * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
     */
    public Builder setBeh(
        openfmb.commonmodule.ENS_BehaviourModeKind.Builder builderForValue) {
      if (behBuilder_ == null) {
        beh_ = builderForValue.build();
      } else {
        behBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Behavior of the function
     * </pre>
     *
     * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
     */
    public Builder mergeBeh(openfmb.commonmodule.ENS_BehaviourModeKind value) {
      if (behBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          beh_ != null &&
          beh_ != openfmb.commonmodule.ENS_BehaviourModeKind.getDefaultInstance()) {
          getBehBuilder().mergeFrom(value);
        } else {
          beh_ = value;
        }
      } else {
        behBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Behavior of the function
     * </pre>
     *
     * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
     */
    public Builder clearBeh() {
      bitField0_ = (bitField0_ & ~0x00000002);
      beh_ = null;
      if (behBuilder_ != null) {
        behBuilder_.dispose();
        behBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Behavior of the function
     * </pre>
     *
     * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
     */
    public openfmb.commonmodule.ENS_BehaviourModeKind.Builder getBehBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getBehFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Behavior of the function
     * </pre>
     *
     * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
     */
    public openfmb.commonmodule.ENS_BehaviourModeKindOrBuilder getBehOrBuilder() {
      if (behBuilder_ != null) {
        return behBuilder_.getMessageOrBuilder();
      } else {
        return beh_ == null ?
            openfmb.commonmodule.ENS_BehaviourModeKind.getDefaultInstance() : beh_;
      }
    }
    /**
     * <pre>
     * Behavior of the function
     * </pre>
     *
     * <code>.commonmodule.ENS_BehaviourModeKind Beh = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_BehaviourModeKind, openfmb.commonmodule.ENS_BehaviourModeKind.Builder, openfmb.commonmodule.ENS_BehaviourModeKindOrBuilder> 
        getBehFieldBuilder() {
      if (behBuilder_ == null) {
        behBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ENS_BehaviourModeKind, openfmb.commonmodule.ENS_BehaviourModeKind.Builder, openfmb.commonmodule.ENS_BehaviourModeKindOrBuilder>(
                getBeh(),
                getParentForChildren(),
                isClean());
        beh_ = null;
      }
      return behBuilder_;
    }

    private openfmb.commonmodule.ENS_HealthKind eEHealth_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_HealthKind, openfmb.commonmodule.ENS_HealthKind.Builder, openfmb.commonmodule.ENS_HealthKindOrBuilder> eEHealthBuilder_;
    /**
     * <pre>
     * Asset health
     * </pre>
     *
     * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
     * @return Whether the eEHealth field is set.
     */
    public boolean hasEEHealth() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Asset health
     * </pre>
     *
     * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
     * @return The eEHealth.
     */
    public openfmb.commonmodule.ENS_HealthKind getEEHealth() {
      if (eEHealthBuilder_ == null) {
        return eEHealth_ == null ? openfmb.commonmodule.ENS_HealthKind.getDefaultInstance() : eEHealth_;
      } else {
        return eEHealthBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Asset health
     * </pre>
     *
     * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
     */
    public Builder setEEHealth(openfmb.commonmodule.ENS_HealthKind value) {
      if (eEHealthBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        eEHealth_ = value;
      } else {
        eEHealthBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Asset health
     * </pre>
     *
     * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
     */
    public Builder setEEHealth(
        openfmb.commonmodule.ENS_HealthKind.Builder builderForValue) {
      if (eEHealthBuilder_ == null) {
        eEHealth_ = builderForValue.build();
      } else {
        eEHealthBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Asset health
     * </pre>
     *
     * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
     */
    public Builder mergeEEHealth(openfmb.commonmodule.ENS_HealthKind value) {
      if (eEHealthBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          eEHealth_ != null &&
          eEHealth_ != openfmb.commonmodule.ENS_HealthKind.getDefaultInstance()) {
          getEEHealthBuilder().mergeFrom(value);
        } else {
          eEHealth_ = value;
        }
      } else {
        eEHealthBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Asset health
     * </pre>
     *
     * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
     */
    public Builder clearEEHealth() {
      bitField0_ = (bitField0_ & ~0x00000004);
      eEHealth_ = null;
      if (eEHealthBuilder_ != null) {
        eEHealthBuilder_.dispose();
        eEHealthBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Asset health
     * </pre>
     *
     * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
     */
    public openfmb.commonmodule.ENS_HealthKind.Builder getEEHealthBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getEEHealthFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Asset health
     * </pre>
     *
     * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
     */
    public openfmb.commonmodule.ENS_HealthKindOrBuilder getEEHealthOrBuilder() {
      if (eEHealthBuilder_ != null) {
        return eEHealthBuilder_.getMessageOrBuilder();
      } else {
        return eEHealth_ == null ?
            openfmb.commonmodule.ENS_HealthKind.getDefaultInstance() : eEHealth_;
      }
    }
    /**
     * <pre>
     * Asset health
     * </pre>
     *
     * <code>.commonmodule.ENS_HealthKind EEHealth = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_HealthKind, openfmb.commonmodule.ENS_HealthKind.Builder, openfmb.commonmodule.ENS_HealthKindOrBuilder> 
        getEEHealthFieldBuilder() {
      if (eEHealthBuilder_ == null) {
        eEHealthBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ENS_HealthKind, openfmb.commonmodule.ENS_HealthKind.Builder, openfmb.commonmodule.ENS_HealthKindOrBuilder>(
                getEEHealth(),
                getParentForChildren(),
                isClean());
        eEHealth_ = null;
      }
      return eEHealthBuilder_;
    }

    private openfmb.commonmodule.StatusSPS hotLineTag_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> hotLineTagBuilder_;
    /**
     * <pre>
     * Hot line tag.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
     * @return Whether the hotLineTag field is set.
     */
    public boolean hasHotLineTag() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * Hot line tag.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
     * @return The hotLineTag.
     */
    public openfmb.commonmodule.StatusSPS getHotLineTag() {
      if (hotLineTagBuilder_ == null) {
        return hotLineTag_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : hotLineTag_;
      } else {
        return hotLineTagBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Hot line tag.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
     */
    public Builder setHotLineTag(openfmb.commonmodule.StatusSPS value) {
      if (hotLineTagBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        hotLineTag_ = value;
      } else {
        hotLineTagBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Hot line tag.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
     */
    public Builder setHotLineTag(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (hotLineTagBuilder_ == null) {
        hotLineTag_ = builderForValue.build();
      } else {
        hotLineTagBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Hot line tag.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
     */
    public Builder mergeHotLineTag(openfmb.commonmodule.StatusSPS value) {
      if (hotLineTagBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          hotLineTag_ != null &&
          hotLineTag_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getHotLineTagBuilder().mergeFrom(value);
        } else {
          hotLineTag_ = value;
        }
      } else {
        hotLineTagBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Hot line tag.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
     */
    public Builder clearHotLineTag() {
      bitField0_ = (bitField0_ & ~0x00000008);
      hotLineTag_ = null;
      if (hotLineTagBuilder_ != null) {
        hotLineTagBuilder_.dispose();
        hotLineTagBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Hot line tag.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getHotLineTagBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getHotLineTagFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Hot line tag.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getHotLineTagOrBuilder() {
      if (hotLineTagBuilder_ != null) {
        return hotLineTagBuilder_.getMessageOrBuilder();
      } else {
        return hotLineTag_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : hotLineTag_;
      }
    }
    /**
     * <pre>
     * Hot line tag.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS HotLineTag = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getHotLineTagFieldBuilder() {
      if (hotLineTagBuilder_ == null) {
        hotLineTagBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getHotLineTag(),
                getParentForChildren(),
                isClean());
        hotLineTag_ = null;
      }
      return hotLineTagBuilder_;
    }

    private openfmb.commonmodule.StatusSPS remoteBlk_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> remoteBlkBuilder_;
    /**
     * <pre>
     * Remote control block.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
     * @return Whether the remoteBlk field is set.
     */
    public boolean hasRemoteBlk() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * Remote control block.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
     * @return The remoteBlk.
     */
    public openfmb.commonmodule.StatusSPS getRemoteBlk() {
      if (remoteBlkBuilder_ == null) {
        return remoteBlk_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : remoteBlk_;
      } else {
        return remoteBlkBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Remote control block.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
     */
    public Builder setRemoteBlk(openfmb.commonmodule.StatusSPS value) {
      if (remoteBlkBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        remoteBlk_ = value;
      } else {
        remoteBlkBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Remote control block.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
     */
    public Builder setRemoteBlk(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (remoteBlkBuilder_ == null) {
        remoteBlk_ = builderForValue.build();
      } else {
        remoteBlkBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Remote control block.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
     */
    public Builder mergeRemoteBlk(openfmb.commonmodule.StatusSPS value) {
      if (remoteBlkBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          remoteBlk_ != null &&
          remoteBlk_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getRemoteBlkBuilder().mergeFrom(value);
        } else {
          remoteBlk_ = value;
        }
      } else {
        remoteBlkBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Remote control block.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
     */
    public Builder clearRemoteBlk() {
      bitField0_ = (bitField0_ & ~0x00000010);
      remoteBlk_ = null;
      if (remoteBlkBuilder_ != null) {
        remoteBlkBuilder_.dispose();
        remoteBlkBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Remote control block.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getRemoteBlkBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getRemoteBlkFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Remote control block.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getRemoteBlkOrBuilder() {
      if (remoteBlkBuilder_ != null) {
        return remoteBlkBuilder_.getMessageOrBuilder();
      } else {
        return remoteBlk_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : remoteBlk_;
      }
    }
    /**
     * <pre>
     * Remote control block.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS RemoteBlk = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getRemoteBlkFieldBuilder() {
      if (remoteBlkBuilder_ == null) {
        remoteBlkBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getRemoteBlk(),
                getParentForChildren(),
                isClean());
        remoteBlk_ = null;
      }
      return remoteBlkBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.LogicalNodeForEventAndStatus)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.LogicalNodeForEventAndStatus)
  private static final openfmb.commonmodule.LogicalNodeForEventAndStatus DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.LogicalNodeForEventAndStatus();
  }

  public static openfmb.commonmodule.LogicalNodeForEventAndStatus getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<LogicalNodeForEventAndStatus>
      PARSER = new com.google.protobuf.AbstractParser<LogicalNodeForEventAndStatus>() {
    @java.lang.Override
    public LogicalNodeForEventAndStatus parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<LogicalNodeForEventAndStatus> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<LogicalNodeForEventAndStatus> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForEventAndStatus getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

